--[[
	Simple addon by NerfedWar (nerfed.war@gmail.com) that uses Wildtide's WT Addon Framework
	Wildtide @ Blightweald (EU) / DoomSprout @ forums.riftgame.com
--]]

local toc, data = ...
local AddonId = toc.identifier
local AddonVersion = toc.version

local gadgetIndex = 0
local ilGadgets = {}


local function Create(configuration)
	local ilFrame = UI.CreateFrame("Texture", configuration.id, WT.Context)
	ilFrame:SetTexture(configuration.addonName, configuration.imageName);
	-- boundry checks
	if ilFrame:GetWidth()<1 then ilFrame:SetTexture("Gadgets_Images", "images/blank.png"); end
	-- set layer
	ilFrame:SetLayer(tonumber(configuration.imageLayer))
	-- register gadget
	table.insert(ilGadgets, ilFrame)
	return ilFrame, { resizable={16,16,5000,5000} }
end


local ilDialog = false
local function ilConfigDialog(container)
dump(container)
	ilDialog = WT.Dialog(container)
		:Label("This gadget loads and displays an image on screen.")
		:FieldNote("Enter the name of the image you want to load. Images should reside in the images subdirectory of the Gadgets_Images addon.")
		:Textfield("addonName", "Name of the addon in which the image is located", "Gadgets_Images")
		:Textfield("imageName", "Image Name", "images/d3_demon.png")
		:Textfield("imageLayer", "Image Layer", "100")
end


local function ilGetConfiguration()
	local config = ilDialog:GetValues()
	return config
end


local function ilSetConfiguration(config)
	ilDialog:SetValues(config)
end

	
WT.Gadget.RegisterFactory("Images",
	{
		name="Image Loader",
		description="Loads and display an image on-screen.",
		author="NerfedWar",
		version=AddonVersion,
		iconTexAddon=AddonId,
		iconTexFile="images/Gadgets_Images_Icon.png",
		["Create"] = Create,
		["ConfigDialog"] = ilConfigDialog,
		["GetConfiguration"] = ilGetConfiguration, 
		["SetConfiguration"] = ilSetConfiguration, 
	})